// Demonstration of using JCWindow with ncurses PANELs.
assert(include('JCWindow.inc'));

if( 1 ) {

	// Set up a root panel the size of stdscr:
	var root = new JCWindow(nc_new_panel(nc_initscr()));
	root.bottom();
	root.background(nc_color_pair("yellow","cyan") | ncurses.A_BOLD);
	root.border();
	root.addstr(0,2," Panel demo ");

	var sht = root.height();
	var swt = root.width();

	// Set up a console panel to capture cout:
	var tmp = nc_newwin(sht-2,swt-2,1,1);
	root.console = new JCWindow(nc_new_panel(tmp));
	root.console.background(nc_color_pair("green","black")|ncurses.A_UNDERLINE);
	root.console.scrollok(true);
  	nc_capture_cout(root.console.window);
	root.console.movecursor(sht/2,0);

	// Set up a misc window...
	tmp = nc_newwin(sht/2,swt/3,1,swt/2);
	root.blurb = new JCWindow(nc_new_panel(tmp));
	root.blurb.background(ascii(' ')|nc_color('yellow','black')|ncurses.A_BOLD|ncurses.A_UNDERLINE);
	root.blurb.border();
	root.blurb.addstr(1,1,"Blurb!");

	// Set up another misc window:
	tmp = nc_newwin( sht/2,swt/5*3,sht/2-1,swt/5*2-1);
	root.block = new JCWindow( nc_new_panel(tmp) );
	root.block.background(nc_color('white','red'));
	root.block.scrollok(true);
	root.signals.getch.connect( new Slot(
					     function(jcw,key) {
							     root.block.addstr('tap test: '+key+" : "+ncurses[key]+'\n');
					     } ) );

	// Set up another misc window:
	tmp = nc_newwin( sht/4,swt/5*3,sht/3,swt/5*2-5);
	root.misc = new JCWindow( nc_new_panel(tmp) );
	root.misc.background(nc_color('blue','white'));
	root.misc.scrollok(true);
	root.misc.addstr("Hi, world.");


	root.block.top();

	// Reimplement root.refresh() to update
	// the panels instead of stdscr.
	root.refresh = function() {
		nc_update_panels();
		nc_doupdate();
		this.signals.refresh.fire(this);
		return 0;
	}

	// Helper function:
	function tap(msg) {
		msg = msg+"\n[TAP A KEY TO CONTINUE]";
		if( 1 ) {
			// different ways of rendering stuff
			// to a window...
			if( 0 ) {
				root.console.addstr(msg+"\n");
			}
			else if( 0 )
			{
				nc_wrender(root.console, msg, "\n");
			}
			else
			{
				function bogo(win) {
					var m = msg;
					nc_wrender(win,m,"\n");
					return true;
				}
				nc_wrender(root.console,bogo);
			}
		} else {
			print(msg);
		}
		//nc_beep();
		root.refresh();
		root.getch();
	}

	tap("Got this far.");
	root.blurb.hide();
	tap("blurb hidden.");
	root.blurb.show();
	root.blurb.top();
	tap("blurb shown, moved to top.");
	root.blurb.movewin(0,0);
	tap("blurb moved.");
	root.blurb.movewin(sht/3,swt-root.blurb.width()-1);
	tap("blurb moved again.");

	root.blurb.destroy();
	delete root.blurb;
	tap("Blurb destroyed. Done.");
 	nc_capture_end(root.console.window);
}


cerr("Done.");
nc_endwin();
cerr("Really done.");

